#include 'UDF\I2D_Nano.au3'

_GDIPlus_Startup()

Local $vIMG = _I2D_BufferCreateFromFile(@ScriptDir & '\unnamed.png') ; Buffer laden

_I2D_BufferFixLines($vIMG, 0xFF606060)

_GDIPlus_ImageSaveToFile($vIMG.BMP, @ScriptDir & '\test.png') ; Anbindung an GDI+ ist da. in vIMG.BMP steckt ein ganz normales GDI+ Bitmap

_GDIPlus_Shutdown()


Func _I2D_BufferFixLines($vIMG, $iCol)
	Local $vBMP = DllStructCreate('int a[' & $vIMG.WIDTH * $vIMG.HEIGHT & ']', $vIMG.PTR), $iCnt = 0
	For $x = 1 To $vIMG.WIDTH - 2 Step 1
		For $y = 1 To $vIMG.HEIGHT - 2 Step 1
			If DllStructGetData($vBMP, 1, $x + $y * $vIMG.WIDTH + 1) = $iCol Then
				$iCnt = 0
				If DllStructGetData($vBMP, 1, ($x - 1) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x - 1) + ($y + 0) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x - 1) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x + 0) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x + 0) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x + 1) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x + 1) + ($y + 0) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If DllStructGetData($vBMP, 1, ($x + 1) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then $iCnt += 1
				If $iCnt >= 5 Then
					If DllStructGetData($vBMP, 1, ($x - 1) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x - 1) + ($y - 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x - 1) + ($y + 0) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x - 1) + ($y + 0) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x - 1) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x - 1) + ($y + 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x + 0) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x + 0) + ($y - 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x + 0) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x + 0) + ($y + 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x + 1) + ($y - 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x + 1) + ($y - 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x + 1) + ($y + 0) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x + 1) + ($y + 0) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf
					If DllStructGetData($vBMP, 1, ($x + 1) + ($y + 1) * $vIMG.WIDTH + 1) <> $iCol Then
						DllStructSetData($vBMP, 1, DllStructGetData($vBMP, 1, ($x + 1) + ($y + 1) * $vIMG.WIDTH + 1), $x + $y * $vIMG.WIDTH + 1)
						ContinueLoop
					EndIf

				EndIf
			EndIf
		Next
	Next
EndFunc